#!/usr/bin/perl -w
use strict;
use POSIX qw(setsid);

my $language = "";
my $region = "";
my $values1 = "";
my $is_PrinterUtility_running = "";
my $retry = 10;
my $PUstr = "PrinterUtility";			

my $pid = fork();
if ($pid) # parent
{
    exit(0);
}
elsif ($pid == 0) # child
{
    setsid();
    my $data = $ENV{LANG};
    my @env1 = split('\.', $data);
    my $counter1 = 1;

    foreach $values1 (@env1)
    {
       if ($counter1 == 1)
       {
          $counter1 = 2;
          my @env2 = split('_', $values1);
          my $counter2 = 1;
          foreach my $values2 (@env2)
          {
             if ($counter2 == 1)
             {
               $language = $values2;
               $counter2 = 2;
             }
             else
             {
               $region = $values2;
             }

          }
       }
    }

    #
    # We retrieve the current OEM from which we are running. We will use this
    # info for a more granular checking of multiple APP instances. The oem name
    # is seen on the path passed as an argument to this script.
    #
    # If the first character is a '/', then remove it. this ill give a "safer"
    # assumption that OEM will be in the 3rd element
    #
    my $path=$ARGV[0];
    $path=~s/^\///;
    my @items=split(/\//,$path);
    my $oem=$items[2];

    # Make sure we run the launcher after PrinterUtility exits. If we don't,
    # the launcher will not run. See $APP_INSTANCE checking in luancher script.
    while($retry >= 1) {
        $is_PrinterUtility_running = `ps -ef | grep $PUstr | grep $oem | grep -v grep`;
        if($is_PrinterUtility_running) {
            sleep(1);
        }
        else {
            last;
        }
        $retry = $retry - 1;
    }

    if($retry == 0) {
        exit(1);
    }

    system("$ARGV[0] $language $region");
    exit(0);

}
else
{
    die "Unable to fork process: $!\n";
}
